function Count() {
    this.circle = this.text = this.img = undefined;
}

Count.prototype.setNewText = function(str) {
    this.clear();
    this.circle = new paper.Path.Circle(new paper.Point(constants.GAME_WIDTH / 2, constants.GAME_HEIGHT / 2), settings.CIRCLE_RADIUS);
    this.circle.fillColor = settings.CIRCLE_COLOR;

    this.text = new paper.PointText({
        content: str,
        fillColor: settings.TEXT_IN_CIRCLE_COLOR,
        fontFamily: 'Times new roman',
        fontWeight: 'bold',
        fontSize: settings.CIRCLE_FONT_SIZE
    });

    this.text.position = this.circle.position;

    var allGroup = new paper.Group([this.circle, this.text]);
    this.img = allGroup.rasterize();

    allGroup.remove();
    this.circle.remove();
    this.text.remove();
    allGroup = undefined;
    this.circle = undefined;
    this.text = undefined;
}

Count.prototype.onFrame = function() {
    if(typeof (this.img) == "undefined") return;
    this.img.scale(0.995);
    this.img.opacity -= 0.02;
}

Count.prototype.clear = function() {
    if(typeof (this.img) == "undefined") return;
    this.img.remove();
    this.img = undefined;
}