globals.loadGameData = function() {
    variables.imagesLoaded = 0;
    variables.totalImages = 8;

    variables.weaponImage = new Image();
    utils.setImageLoadListener(variables.weaponImage);
    variables.weaponImage.src = settings.GUN_IMAGE_PATH;

    variables.backgroundImage = new Image();
    utils.setImageLoadListener(variables.backgroundImage);
    variables.backgroundImage.src = settings.BACKGROUND_IMAGE_PATH;

    utils.loadOneImage(settings.CROSS_IMAGE_PATH);
    utils.loadOneImage(settings.SHOT_IMAGE_PATH);

    variables.targetImage = new Image();
    utils.setImageLoadListener(variables.targetImage);
    variables.targetImage.src = settings.TARGET_IMAGE_PATH;

    variables.livePinguinImage = new Image();
    utils.setImageLoadListener(variables.livePinguinImage);
    variables.livePinguinImage.src = settings.LIVE_PINGUIN_IMAGE_PATH;

    variables.deadPinguinImage = new Image();
    utils.setImageLoadListener(variables.deadPinguinImage);
    variables.deadPinguinImage.src = settings.DEAD_PINGUIN_IMAGE_PATH;

    utils.loadOneImage(settings.HIT_POINT_IMAGE_PATH);
}

utils.loadOneImage = function(imagePath) {
    var img = new Image();
    utils.setImageLoadListener(img);
    img.src = imagePath;
}

utils.setImageLoadListener = function(img) {
    var oneImageLoaded = function() {
        variables.imagesLoaded++;
        if (variables.imagesLoaded == variables.totalImages) {
            domElements.$preloader.addClass(domElements.invisibleClassName);
            globals.initGameObjects();
        }
    }
    img.onload = function(e) {
        oneImageLoaded();
    };
    img.onerror = function(e) {
        oneImageLoaded();
        alert(img.src + " is missing");
    }
}

globals.initGameObjects = function() {
    if(settings.RECORDS_ENABLED) {
        objects.server = new Server();
        objects.records = new Records();
    }// RECORDS
    objects.intro = new Intro();
    objects.game = new Game();
    utils.turnOnScreen(domElements.$introScreen);
}


globals.init = function() {
    var canvas = document.getElementById("canvas");
    paper.setup(canvas);
    globals.loadGameData();
    utils.setVirtualMouseEvents();
    utils.setOrientationChangeListener(); // RESIZE
    utils.resizeAll();
    $(window).resize(function(e) {
        utils.resizeAll();
    });
};

globals.init();