function Screen() {
    this.background = undefined;
    this.backgroundWidth = this.backgroundHeight = undefined;
    this.xOffsetPerPoint = this.yOffsetPerPoint = undefined;

    this.paralaxSpeed = this.paralaxTartgetPoint = undefined;

    this.setParameters();
    this.setView();
}

Screen.prototype.setParameters = function() {
    this.backgroundWidth = constants.GAME_WIDTH + settings.PARALAX_PIXELS;
    this.backgroundHeight = constants.GAME_HEIGHT + settings.PARALAX_PIXELS * (constants.GAME_HEIGHT / constants.GAME_WIDTH);

    this.xOffsetPerPoint = settings.PARALAX_PIXELS / constants.GAME_WIDTH;
    this.yOffsetPerPoint = (this.backgroundHeight - constants.GAME_HEIGHT) / this.backgroundHeight;
}

Screen.prototype.setView = function() {
    var targetWidth = this.backgroundWidth;
    var targetHeight = variables.backgroundImage.height * (targetWidth / variables.backgroundImage.width);
    if(targetHeight < this.backgroundHeight) {
        targetHeight = this.backgroundHeight;
        targetWidth = variables.backgroundImage.width * (targetHeight / variables.backgroundImage.height);
    }
    this.background = new paper.Raster(variables.backgroundImage);
    this.background.position = new paper.Point(targetWidth / 2, targetHeight / 2);
    this.background.size = new paper.Size(targetWidth, targetHeight);
}

Screen.prototype.setParalax = function(mousePoint) {
    this.paralaxTartgetPoint = new paper.Point(this.background.size.width / 2 - mousePoint.x * this.xOffsetPerPoint,
            this.background.size.height / 2 - mousePoint.y * this.yOffsetPerPoint);
    this.paralaxSpeed = settings.PARALAX_SPEED;
}

Screen.prototype.onFrame = function() {
    if(typeof (this.paralaxTartgetPoint) != "undefined") this.moveToParalax();
}

Screen.prototype.moveToParalax = function() {
    var distance = this.background.position.getDistance(this.paralaxTartgetPoint);

    if(distance < settings.PARALAX_SPEED * 3) this.paralaxSpeed /= 1.25;
    if(distance < this.paralaxSpeed) {
        this.background.position = this.paralaxTartgetPoint;
        this.paralaxTartgetPoint = undefined;
        return;
    }


    var L = this.paralaxSpeed / distance;
    this.background.position.x = (1 - L) * this.background.position.x + L * this.paralaxTartgetPoint.x;
    this.background.position.y = (1 - L) * this.background.position.y + L * this.paralaxTartgetPoint.y;
}