function Target() {
    this.target = this.livePinguin = this.deadPinguin = this.hitPoint = undefined;
    this.alive = false;
    this.x = this.y = undefined;

    this.xSpeed = this.ySpeed = this.zSpeed = this.gravity = this.friction = undefined;
    this.startLevelXSpeed = this.startLevelYSpeed = this.startLevelZSpeed = undefined;
    this.fallDownSpeed = this.scale = this.levelGravity = undefined;

    this.hitPointX = this.hitPointY = undefined;

    this.text = undefined;

    this.paralaxSpeed = this.paralaxCurrentPoint = this.paralaxTartgetPoint = undefined;

    this.points = 0;
    this.minusOffsetX = this.minusOffsetY = 0;
    this.paralaxCurrentPoint = new paper.Point(0, 0);
}

Target.prototype.setPictures = function() {
    this.target = new paper.Raster(variables.targetImage);
    objects.game.weapon.moveObjectBelow(this.target);
    this.target.visible = false;

    this.livePinguin = new paper.Raster(variables.livePinguinImage);
    objects.game.weapon.moveObjectBelow(this.livePinguin);
    this.livePinguin.visible = false;

    this.deadPinguin = new paper.Raster(variables.deadPinguinImage);
    objects.game.weapon.moveObjectBelow(this.deadPinguin);
    this.deadPinguin.visible = false;

    this.hitPoint = new paper.Raster(settings.HIT_POINT_IMAGE_PATH);
    objects.game.weapon.moveObjectBelow(this.hitPoint);
    this.hitPoint.visible = false;
}

Target.prototype.setStartParameters = function() {
    this.startLevelXSpeed = settings.TARGET_START_X_SPEED;
    this.startLevelYSpeed = settings.TARGET_START_Y_SPEED;
    this.startLevelZSpeed = settings.TARGET_START_Z_SPEED;
    this.levelGravity = settings.TARGET_START_GRAVITY_RATIO;
}

Target.prototype.setNextLevelParameters = function() {
    this.startLevelXSpeed += settings.TARGET_PLUS_LEVEL_X_SPEED;
    this.startLevelYSpeed += settings.TARGET_PLUS_LEVEL_Y_SPEED;
    this.startLevelZSpeed += settings.TARGET_PLUS_LEVEL_Z_SPEED;
    this.levelGravity -= settings.TARGET_PLUS_LEVEL_GRAVITY_RATIO;
}

Target.prototype.setLevelParameters = function() {
    this.x = Math.round(Math.random() * (constants.GAME_WIDTH + settings.PARALAX_PIXELS / 2)) + settings.PARALAX_PIXELS / 4;
    this.y = objects.game.screen.backgroundHeight;

    this.xSpeed = this.startLevelXSpeed + Math.round(Math.random() * (settings.TARGET_VARIATIVE_X_SPEED * 2)) - settings.TARGET_VARIATIVE_X_SPEED;
    if(this.x > (constants.GAME_WIDTH + settings.PARALAX_PIXELS) / 2) this.xSpeed *= -1;

    console.log(this.x + "   " + this.xSpeed);
    this.friction = (settings.TARGET_FRICTION + Math.round(Math.random() + (settings.TARGET_FRICTION_VARIATIVITY * 2))
            - settings.TARGET_FRICTION_VARIATIVITY) / 1000;

    this.ySpeed = this.startLevelYSpeed + Math.round(Math.random() * (settings.TARGET_VARIATIVE_Y_SPEED * 2)) - settings.TARGET_VARIATIVE_Y_SPEED;
    this.gravity = this.ySpeed / (this.levelGravity + Math.round(Math.random() * (settings.TARGET_GRAVITY_VARIATIVE_RATIO * 2))
            - settings.TARGET_GRAVITY_VARIATIVE_RATIO);

    this.zSpeed = (this.startLevelZSpeed + Math.round(Math.random() * (settings.TARGET_VARIATIVE_Z_SPEED * 2))
            - settings.TARGET_VARIATIVE_Z_SPEED) / 1000;

    this.fallDownSpeed = settings.TARGET_FALL_DOWN_SPEED + Math.round(Math.random() * (settings.TARGET_FALL_DOWN_VARIATIVE_SPEED * 2)) - settings.TARGET_FALL_DOWN_VARIATIVE_SPEED;
}

Target.prototype.born = function() {
    this.alive = true;
    this.points = 0;
    this.scale = 1;
    this.setPictures();
    this.livePinguin.visible = true;
    this.setLevelParameters();
    this.setObjectsSize();
    this.setObjectsPosition();
}

Target.prototype.setObjectsSize = function() {
    if(this.livePinguin.visible) {
        this.livePinguin.scale(1 - this.zSpeed);
        this.deadPinguin.scale(1 - this.zSpeed);
        this.target.scale(1 - this.zSpeed);
    }
}

Target.prototype.setObjectsPosition = function() {
    if(this.livePinguin.visible) {
        this.livePinguin.position = new paper.Point(this.x + this.minusOffsetX, this.y + this.minusOffsetY);
    }
    if(this.target.visible) {
        this.deadPinguin.position = new paper.Point(this.x + this.minusOffsetX, this.y + this.minusOffsetY);
        this.target.position.x = this.deadPinguin.position.x;
        this.target.position.y = this.deadPinguin.position.y - this.deadPinguin.size.height * this.deadPinguin.matrix.scaling.y / 2
                - this.target.size.height * this.target.matrix.scaling.y / 2;
        if(this.hitPoint.visible) {
            this.hitPoint.position = new paper.Point(this.target.position.x + this.hitPointX, this.target.position.y + this.hitPointY);
        }
//        if(typeof (this.text) != "undefined") {
//            this.text.position.x = this.text.position.x + this.minusOffsetX;
//            this.text.position.y = this.text.position.y + this.minusOffsetY;
//        }
    }
}

Target.prototype.checkShot = function(mousePoint) {
    if(this.target.visible) {
        if(this.hitPoint.visible) return;
        var targetSize = this.target.size.width * this.target.matrix.scaling.x;
        var distance = mousePoint.getDistance(this.target.position);
        if(distance < targetSize / 2) {
            var percentPoints = 100 - (distance / (targetSize / 2) * 100);
            this.points = Math.round((settings.MAX_TARGET_POINTS - settings.MIN_TARGET_POINTS) * percentPoints / 100) + settings.MIN_TARGET_POINTS;
            this.points = Math.max(settings.MIN_TARGET_POINTS, this.points);
            this.points = Math.min(settings.MAX_TARGET_POINTS, this.points);
            console.log("TargetSize/2 = " + (targetSize / 2) + "   Distance = " + distance + "   PercentPoints = " + percentPoints + "   Points = " + this.points);
            this.addHitPoint(mousePoint);
            this.addText(mousePoint);
            $(this).trigger(events.TARGET_SHOT);
        }
    }
    if(this.livePinguin.visible && this.livePinguin.hitTest(mousePoint) != null) {
        this.livePinguin.visible = false;
        this.setDeadPinguinParameters();
    }
}

Target.prototype.addText = function(mousePoint) {
    this.text = new paper.PointText({
        content: this.points,
        fillColor: settings.POINTS_TEXT_COLOR,
        fontFamily: 'Roboto',
        fontWeight: 'bold',
        fontSize: settings.POINTS_TEXT_SIZE
    });
    this.text.position = this.target.position;
}

Target.prototype.addHitPoint = function(mousePoint) {
    this.hitPointX = mousePoint.x - this.target.position.x;
    this.hitPointY = mousePoint.y - this.target.position.y;
    this.hitPoint.visible = true;
    this.hitPoint.position = new paper.Point(this.target.position.x + this.hitPointX, this.target.position.y + this.hitPointY);
}

Target.prototype.setDeadPinguinParameters = function() {
    this.deadPinguin.visible = true;
    this.target.visible = true;
    this.setObjectsPosition();
}

Target.prototype.setParalax = function(mousePoint) {
    this.paralaxTartgetPoint = new paper.Point(objects.game.screen.background.size.width / 2 - mousePoint.x * objects.game.screen.xOffsetPerPoint,
            objects.game.screen.background.size.height / 2 - mousePoint.y * objects.game.screen.yOffsetPerPoint);
    this.paralaxSpeed = settings.PARALAX_SPEED;
}

Target.prototype.moveToParalax = function() {
    var distance = this.paralaxTartgetPoint.getDistance(this.paralaxCurrentPoint);

    if(distance < settings.PARALAX_SPEED * 3) this.paralaxSpeed /= 1.25;
    if(distance < this.paralaxSpeed) {
        this.paralaxTartgetPoint = undefined;
        return;
    }


    var L = this.paralaxSpeed / distance;
    this.paralaxCurrentPoint.x = (1 - L) * this.paralaxCurrentPoint.x + L * this.paralaxTartgetPoint.x;
    this.paralaxCurrentPoint.y = (1 - L) * this.paralaxCurrentPoint.y + L * this.paralaxTartgetPoint.y;

    this.minusOffsetX = (this.paralaxCurrentPoint.x * objects.game.screen.xOffsetPerPoint) * 2 - objects.game.screen.background.size.width / 2;
    this.minusOffsetY = (this.paralaxCurrentPoint.y * objects.game.screen.yOffsetPerPoint) * 2 - objects.game.screen.background.size.height / 2;
}

Target.prototype.onFrame = function() {
    if(typeof (this.paralaxTartgetPoint) != "undefined") this.moveToParalax();
    if(!this.alive) return;
    if(this.livePinguin.visible) {
        this.x += this.xSpeed;
        this.y -= this.ySpeed;
        this.xSpeed = this.xSpeed > 0 ? this.xSpeed - this.friction : this.xSpeed + this.friction;
        this.ySpeed -= this.gravity;
    }else if(this.target.visible){
//        console.log("OffsetX = " + this.minusOffsetX + "   targetPositionX = " + this.target.position.x + "   ThisX = " + this.x);
        this.y += this.fallDownSpeed;
    }

    if(typeof (this.text) != "undefined") {
        this.text._opacity -= 0.005;
        this.text.position.y -= 2;
    }

    this.setObjectsSize();
    this.setObjectsPosition();

    if(this.y > objects.game.screen.backgroundHeight + 100) this.dispatchOutEvent();
}

Target.prototype.dispatchOutEvent = function() {
    this.alive = false;
    if(this.livePinguin.visible) {
        $(this).trigger(events.TARGET_ESCAPED);
    }else if(this.target.visible) {
        $(this).trigger(events.TARGET_MISSED);
    }
    this.clear();
}

Target.prototype.clear = function() {
    if(typeof(this.livePinguin) == "undefined") return;
    this.livePinguin.remove();
    this.deadPinguin.remove();
    this.target.remove();
    this.hitPoint.remove();
    if(typeof (this.text) != "undefined") this.text.remove();
    this.livePinguin = this.deadPinguin = this.target = this.hitPoint = this.text = undefined;
}